<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Stdlib\CookieManagerInterface;

class AddGaCidToOrder implements ObserverInterface
{
    /** @var CookieManagerInterface */
    protected $cookieManager;

    public function __construct(CookieManagerInterface $cookieManager) {
        $this->cookieManager = $cookieManager;
    }
    
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        /* @var $order \Magento\Sales\Model\Order */
        $order = $observer->getEvent()->getOrder();

        try {
            $cid = $this->cookieManager->getCookie('_ga');
            $order->setData('ga_cid', $cid);
        } catch (\Exception $exception) {
            throw new \Exception($exception->getMessage());
        }
    }
}
